diff --git a/Documentation/devicetree/bindings/phy/qcom,qmp-phy.yaml b/Documentation/devicetree/bindings/phy/qcom,qmp-phy.yaml
index 38e0ade01687..83f777b4636f 100644
--- a/Documentation/devicetree/bindings/phy/qcom,qmp-phy.yaml
+++ b/Documentation/devicetree/bindings/phy/qcom,qmp-phy.yaml
@@ -11,7 +11,7 @@ maintainers:
   - Vinod Koul <vkoul@kernel.org>
 
 description:
-  QMP phy controller supports physical layer functionality for a number of
+  QMP PHY controller supports physical layer functionality for a number of
   controllers on Qualcomm chipsets, such as, PCIe, UFS, and USB.
 
 properties:
@@ -107,7 +107,7 @@ patternProperties:
   "^phy@[0-9a-f]+$":
     type: object
     description:
-      Each device node of QMP phy is required to have as many child nodes as
+      Each device node of QMP PHY is required to have as many child nodes as
       the number of lanes the PHY has.
 
 required:
@@ -134,10 +134,10 @@ allOf:
       properties:
         clocks:
           items:
-            - description: Phy aux clock.
-            - description: Phy config clock.
-            - description: 19.2 MHz ref clk.
-            - description: Phy common block aux clock.
+            - description: PHY aux clock.
+            - description: PHY config clock.
+            - description: 19.2 MHz ref clock.
+            - description: PHY common block aux clock.
         clock-names:
           items:
             - const: aux
@@ -146,8 +146,8 @@ allOf:
             - const: com_aux
         resets:
           items:
-            - description: reset of phy block.
-            - description: phy common block reset.
+            - description: Reset of PHY block.
+            - description: PHY common block reset.
         reset-names:
           items:
             - const: phy
@@ -166,9 +166,9 @@ allOf:
       properties:
         clocks:
           items:
-            - description: Phy aux clock.
-            - description: Phy config clock.
-            - description: 19.2 MHz ref clk.
+            - description: PHY aux clock.
+            - description: PHY config clock.
+            - description: 19.2 MHz ref clock.
         clock-names:
           items:
             - const: aux
@@ -176,8 +176,8 @@ allOf:
             - const: ref
         resets:
           items:
-            - description: reset of phy block.
-            - description: phy common block reset.
+            - description: Reset of PHY block.
+            - description: PHY common block reset.
         reset-names:
           items:
             - const: phy
@@ -195,9 +195,9 @@ allOf:
       properties:
         clocks:
           items:
-            - description: Phy aux clock.
-            - description: Phy config clock.
-            - description: 19.2 MHz ref clk.
+            - description: PHY aux clock.
+            - description: PHY config clock.
+            - description: 19.2 MHz ref clock.
         clock-names:
           items:
             - const: aux
@@ -205,9 +205,9 @@ allOf:
             - const: ref
         resets:
           items:
-            - description: reset of phy block.
-            - description: phy common block reset.
-            - description: phy's ahb cfg block reset.
+            - description: Reset of PHY block.
+            - description: PHY common block reset.
+            - description: PHY's ahb cfg block reset.
         reset-names:
           items:
             - const: phy
@@ -229,9 +229,9 @@ allOf:
       properties:
         clocks:
           items:
-            - description: Phy aux clock.
-            - description: Phy config clock.
-            - description: 19.2 MHz ref clk.
+            - description: PHY aux clock.
+            - description: PHY config clock.
+            - description: 19.2 MHz ref clock.
         clock-names:
           items:
             - const: aux
@@ -239,8 +239,8 @@ allOf:
             - const: ref
         resets:
           items:
-            - description: reset of phy block.
-            - description: phy common block reset.
+            - description: Reset of PHY block.
+            - description: PHY common block reset.
         reset-names:
           items:
             - const: phy
@@ -258,7 +258,7 @@ allOf:
       properties:
         clocks:
           items:
-            - description: 19.2 MHz ref clk.
+            - description: 19.2 MHz ref clock.
         clock-names:
           items:
             - const: ref
@@ -287,8 +287,8 @@ allOf:
       properties:
         clocks:
           items:
-            - description: 19.2 MHz ref clk.
-            - description: Phy reference aux clock.
+            - description: 19.2 MHz ref clock.
+            - description: PHY reference aux clock.
         clock-names:
           items:
             - const: ref
@@ -313,16 +313,16 @@ allOf:
       properties:
         clocks:
           items:
-            - description: Phy aux clock.
-            - description: Phy config clock.
+            - description: PHY aux clock.
+            - description: PHY config clock.
         clock-names:
           items:
             - const: aux
             - const: cfg_ahb
         resets:
           items:
-            - description: reset of phy block.
-            - description: phy common block reset.
+            - description: Reset of PHY block.
+            - description: PHY common block reset.
         reset-names:
           items:
             - const: phy
@@ -345,10 +345,10 @@ allOf:
       properties:
         clocks:
           items:
-            - description: Phy aux clock.
-            - description: Phy config clock.
-            - description: 19.2 MHz ref clk.
-            - description: Phy refgen clk.
+            - description: PHY aux clock.
+            - description: PHY config clock.
+            - description: 19.2 MHz ref clock.
+            - description: PHY refgen clock.
         clock-names:
           items:
             - const: aux
@@ -357,7 +357,7 @@ allOf:
             - const: refgen
         resets:
           items:
-            - description: reset of phy block.
+            - description: Reset of PHY block.
         reset-names:
           items:
             - const: phy
@@ -377,10 +377,10 @@ allOf:
       properties:
         clocks:
           items:
-            - description: Phy aux clock.
-            - description: 19.2 MHz ref clk source.
-            - description: 19.2 MHz ref clk.
-            - description: Phy common block aux clock.
+            - description: PHY aux clock.
+            - description: 19.2 MHz ref clock source.
+            - description: 19.2 MHz ref clock.
+            - description: PHY common block aux clock.
         clock-names:
           items:
             - const: aux
@@ -389,8 +389,8 @@ allOf:
             - const: com_aux
         resets:
           items:
-            - description: reset of phy block.
-            - description: phy common block reset.
+            - description: Reset of PHY block.
+            - description: PHY common block reset.
         reset-names:
           items:
             - const: phy
@@ -409,9 +409,9 @@ allOf:
       properties:
         clocks:
           items:
-            - description: Phy aux clock.
-            - description: 19.2 MHz ref clk.
-            - description: Phy common block aux clock.
+            - description: PHY aux clock.
+            - description: 19.2 MHz ref clock.
+            - description: PHY common block aux clock.
         clock-names:
           items:
             - const: aux
@@ -419,8 +419,8 @@ allOf:
             - const: com_aux
         resets:
           items:
-            - description: reset of phy block.
-            - description: phy common block reset.
+            - description: Reset of PHY block.
+            - description: PHY common block reset.
         reset-names:
           items:
             - const: phy
@@ -438,9 +438,9 @@ allOf:
       properties:
         clocks:
           items:
-            - description: Phy config clock.
-            - description: 19.2 MHz ref clk.
-            - description: Phy common block aux clock.
+            - description: PHY config clock.
+            - description: 19.2 MHz ref clock.
+            - description: PHY common block aux clock.
         clock-names:
           items:
             - const: cfg_ahb
@@ -449,7 +449,7 @@ allOf:
         resets:
           items:
             - description: phy_phy reset.
-            - description: reset of phy block.
+            - description: reset of PHY block.
         reset-names:
           items:
             - const: phy_phy